package com.lou.image;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.io.OutputStream;
import java.util.Random;

import javax.imageio.ImageIO;

public class VerifyCode {
	private int w = 70;
	private int h = 35;
 	private Random r = new Random();
 	// {"", "Ŀ", "", "κ", "", "΢ź", "_GB2312"}
	private String[] fontNames  = {"", "Ŀ", "", "΢ź", "_GB2312"};
	// ѡַ
	private String codes  = "23456789abcdefghjkmnopqrstuvwxyzABCDEFGHJKMNPQRSTUVWXYZ";
	// ɫ
	private Color bgColor  = new Color(255, 255, 255);
	// ֤ϵı
	private String text ;
	
	// ɫ
	private Color randomColor () {
		int red = r.nextInt(150);
		int green = r.nextInt(150);
		int blue = r.nextInt(150);
		return new Color(red, green, blue);
	}
	
	// 
	private Font randomFont () {
		int index = r.nextInt(fontNames.length);
		String fontName = fontNames[index];//
		int style = r.nextInt(4);//ʽ, 0(ʽ), 1(), 2(б), 3(+б)
		int size = r.nextInt(5) + 24; //ֺ, 24 ~ 28
		return new Font(fontName, style, size);
	}
	
	// 
	private void drawLine (BufferedImage image) {
		int num  = 3;//һ3
		Graphics2D g2 = (Graphics2D)image.getGraphics();
		for(int i = 0; i < num; i++) {//꣬4ֵ
			int x1 = r.nextInt(w);
			int y1 = r.nextInt(h);
			int x2 = r.nextInt(w);
			int y2 = r.nextInt(h); 
			g2.setStroke(new BasicStroke(1.5F)); 
			g2.setColor(Color.BLUE); //ɫ
			g2.drawLine(x1, y1, x2, y2);//
		}
	}
	
	// һַ
	private char randomChar () {
		int index = r.nextInt(codes.length());
		return codes.charAt(index);
	}
	
	// BufferedImage
	private BufferedImage createImage () {
		BufferedImage image = new BufferedImage(w, h, BufferedImage.TYPE_INT_RGB); 
		Graphics2D g2 = (Graphics2D)image.getGraphics(); 
		g2.setColor(this.bgColor);
		g2.fillRect(0, 0, w, h);
 		return image;
	}
	
	// õ֤
	public BufferedImage getImage () {
		BufferedImage image = createImage();//ͼƬ 
		Graphics2D g2 = (Graphics2D)image.getGraphics();//õƻ
		StringBuilder sb = new StringBuilder();//װɵ֤ı
		// ͼƬл4ַ
		for(int i = 0; i < 4; i++)  {//ѭĴΣÿһַ
			String s = randomChar() + "";//һĸ 
			sb.append(s); //ĸӵsb
			float x = i * 1.0F * w / 4; //õǰַx
			g2.setFont(randomFont()); //
			g2.setColor(randomColor()); //ɫ
			g2.drawString(s, x, h-5); //ͼ
		}
		this.text = sb.toString(); //ɵַthis.text
		drawLine(image); //Ӹ
		return image;		
	}
	
	// ֤ͼƬϵı
	public String getText () {
		return text;
	}
	
	// ͼƬָ
	public static void output (BufferedImage image, OutputStream out) 
				throws IOException {
		ImageIO.write(image, "JPEG", out);
	}
}


